<?php

require_once(dirname(__FILE__) . '/include.php');

/**
 * Плагин
 */
if (TEST_MODE) {
    error_reporting(E_ALL & ~E_NOTICE);
}

if (!defined('_VALID_MOS') && !defined('_JEXEC'))
    die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin')) require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVMPaymentRBSPayment extends vmPSPlugin
{
    public static $_this = false;
    public static $flag = false;
    public $j_version;

    static protected $vats = [
        'none' => 0,
        0      => 1,
        10     => 2,
        18     => 3,
        20     => 6,
    ];

    function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);
        $this->_loggable = true;
        $this->tableFields = array_keys($this->getTableSQLFields());
        $varsToPush = $this->getVarsToPush();
        $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);

        $j = new JVersion();
        $this->j_version = $j->getLongVersion();
    }

    function getTableSQLFields()
    {
        $SQLfields = array(
            'id' => 'int(11) unsigned NOT NULL AUTO_INCREMENT',
            'virtuemart_order_number' => 'char(32) DEFAULT NULL',
            'virtuemart_order_id' => 'char(32) DEFAULT NULL',
            'virtuemart_paymentmethod_id' => 'char(32) DEFAULT NULL',
            'rbs_order_id' => 'char(36) DEFAULT NULL'
        );
        return $SQLfields;
    }

    function plgVmConfirmedOrder($cart, $order)
    {
        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return null;
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }

//        $session = JFactory::getSession();
//        $return_context = $session->getId();

        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }
        if (!class_exists('VirtueMartModelCurrency')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
        }

        $amount = round($order['details']['BT']->order_total * 100);

        $args = Array(
            'userName' => $method->merchant,
            'password' => $method->password,
            'amount' => $amount,
            'orderNumber' => $order['details']['BT']->order_number,
            'returnUrl' => JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&method=payment',
            'jsonParams' => json_encode(array('CMS' => $this->j_version, 'Module-Version' => VERSION)),
        );


        if ($method->rbs_send_order == 1) {
            $itemsCnt = 1;
            $new_amount = 0;

            // варианты налогов (если у продукта default rules, то product_tax_id=0)
            $optionTaxes = array(
                'Tax',
                'DATax',
                'VatTax',
                'bDBTax',
                'bMarge'
            );

            if ($cart->products) {
                foreach ($cart->products as $key => $product) {
                    $price = round($cart->cartPrices[$key]['basePriceVariant'] * 100);
                    $vat = $method->rbs_tax_type;

                    // PRODUCT TAX
                    foreach ($optionTaxes as $selectUserTax) {
                        if (!empty($cart->cartPrices[$key][$selectUserTax])) {
                            $idTax = array_keys($cart->cartPrices[$key][$selectUserTax]);
                            $paramsTax = ShopFunctions::getTaxByID($idTax[0]);
                            $price = round($cart->cartPrices[$key]['salesPrice'] * 100);
                            // in percent ( +, -, +%, -% )
                            if ($paramsTax['calc_value_mathop'] === '+%') {
                                $taxCalcValue = (int)$paramsTax['calc_value'];
                                $vat = isset(self::$vats[$taxCalcValue]) ? self::$vats[$taxCalcValue] : $method->rbs_tax_type;
                            } else {
                                $vat = $method->rbs_tax_type;
                            }
                        }
                    }

                    $item = array();

                    $item['positionId'] = $itemsCnt++;
                    $item['name'] = mb_substr($product->product_name,0,64);
                    $item['quantity'] = array(
                        'value' => $product->quantity,
                        'measure' => (!empty($product->product_unit)) ? $product->product_unit : "piece"
                    );
                    $item['itemAmount'] = round($price * $product->quantity);
                    $item['itemCode'] = $product->virtuemart_product_id;

                    $item['tax'] = array(
                        'taxType' => $vat,
                        'taxSum' => $product->product_tax * 100,
                    );
                    $item['itemPrice'] = $price;

                    // FFD 1.05 added
                    if ($method->ffd_version == 'v105') {

                        $attributes = array();
                        $attributes[] = array(
                            "name" => "paymentMethod",
                            "value" => $method->ffd_paymentMethodType
                        );
                        $attributes[] = array(
                            "name" => "paymentObject",
                            "value" => $method->ffd_paymentObjectType
                        );

                        $item['itemAttributes']['attributes'] = $attributes;
                    }

                    $orderBundle['cartItems']['items'][] = $item;
                    $new_amount += round($price * $product->quantity);
                }
            }


            // DELIVERY POSITION
            if ($order['details']['BT']->order_shipment > 0) {

                $delivery_price = round(($order['details']['BT']->order_shipment + $order['details']['BT']->order_shipment_tax) * 100);

                $tax = ShopFunctions::getTaxByID($cart->cartPrices['shipment_calc_id'][0]);
                $vat = $method->rbs_tax_type;

                if (!empty($tax)) {

                    if ($tax['calc_value_mathop'] === '+%') {
                        $taxCalcValue = (int)$tax['calc_value'];
                        $vat = isset(self::$vats[$taxCalcValue]) ? self::$vats[$taxCalcValue] : self::$method->rbs_tax_type;
                    } else {
                        $vat = self::$method->rbs_tax_type;
                    }
                }

                $delivery = array(
                    'positionId' => $itemsCnt,
                    'name' => "Доставка",
                    'quantity' => array(
                        'value' => 1,
                        'measure' => "piece"
                    ),
                    'itemAmount' => $delivery_price,
                    'itemCode' => "delivery",
                    'tax' => array(
                        //todo: some question taxType
                        'taxType' => $method->rbs_tax_type,
                        'taxSum' => 0,
                    ),
                    'itemPrice' => $delivery_price,
                );

                // FFD 1.05 added
                if ($method->ffd_version == 'v105') {
                    $attributes = array();
                    $attributes[] = array(
                        "name" => "paymentMethod",
                        "value" => $method->ffd_paymentMethodType
                    );
                    $attributes[] = array(
                        "name" => "paymentObject",
                        "value" => 4
                    );
                    $delivery['itemAttributes']['attributes'] = $attributes;
                }

                $orderBundle['cartItems']['items'][] = $delivery;
                $new_amount += $delivery_price;
            }

            // DISCOUNT
            if ($amount != $new_amount) {
                $args['amount'] = $new_amount;
            }

            $args['taxSystem'] = $method->rbs_tax_system;
            $args['orderBundle']['orderCreationDate'] = date('c');
            $args['orderBundle'] = json_encode($orderBundle);

        } //END send_order




        if ($method->test_mode == '1') {
            $action_adr = RBS_TEST_URL;
        } else {
            $action_adr = RBS_PROD_URL;
        }
        if ($method->two_step == '1') {
            $action_adr .= 'register.do';
        } else {
            $action_adr .= 'registerPreAuth.do';
        }

        $rbsCurl = curl_init();
        curl_setopt_array($rbsCurl, array(
            CURLOPT_URL => $action_adr,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_SSL_VERIFYPEER => false,
            CURLOPT_POSTFIELDS => http_build_query($args),
            CURLOPT_HTTPHEADER => array('CMS: ' . $args['CMS'], 'Module-Version: ' . VERSION)
        ));

        $response = curl_exec($rbsCurl);
        curl_close($rbsCurl);
        $response = json_decode($response, true);
//        if ($method->test_mode) {
            $this->rbs_logInfo($action_adr, json_encode($args), json_encode($response));
//        }

        $errorCode = $response['errorCode'];

        $html = '';
        if ($errorCode == 0) {
            $dbValues = array();
            $dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
            $dbValues['virtuemart_order_number'] = $order['details']['BT']->order_number;
            $dbValues['virtuemart_order_id'] = $order['details']['BT']->virtuemart_order_id;
            $dbValues['rbs_order_id'] = $response['orderId'];
            $this->storePSPluginInternalData($dbValues);
            $html .= 'Пожалуйста, нажмите кнопку ниже, чтобы заплатить.<br>';
            $html .= '<a class="button cancel" href="' . $response['formUrl'] . '">Оплатить</a>';
            $_SESSION['merchant'] = $method->merchant;
            $_SESSION['password'] = $method->password;
        } else {
            $html .= 'Ошибка #' . $errorCode . ': ' . $response['errorMessage'];
        }

        return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $method->payment_name);
    }

    function rbs_logInfo($action, $request, $response)
    {
        $file = JPATH_ADMINISTRATOR . "/logs/rbspayment.log";
        $date = JFactory::getDate();
        $fp = fopen($file, 'a');
        fwrite($fp, "\n" . $date->Format('Y-m-d H:i:s') . " " . $action . "\nREQUEST: " . $request . "\nRESPONSE: " . $response . "\n\n");
        fclose($fp);
    }

    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id)
    {
        if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {
            return null;
        }
        $db = JFactory::getDBO();
        $q = 'SELECT * FROM `' . $this->_tablename . '` '
            . 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
        $db->setQuery($q);
        if (!($paymentTable = $db->loadObject())) {
            vmWarn(500, $q . " " . $db->getErrorMsg());
            return '';
        }
        $this->getPaymentCurrency($paymentTable);
        $html = '<table class="adminlist">';
        $html .= $this->getHtmlHeaderBE();
        $html .= $this->getHtmlRowBE('VMPAYMENT_RBSPAYMENT', $paymentTable->payment_name);
        $html .= '</table>';
        return $html;
    }

    function getCosts(VirtueMartCart $cart, $method, $cart_prices)
    {
        if (preg_match('/%$/', $method->cost_percent_total)) {
            $cost_percent_total = substr($method->cost_percent_total, 0, -1);
        } else {
            $cost_percent_total = $method->cost_percent_total;
        }
        return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }

    function plgVmOnPaymentResponseReceived(&$html)
    {
        if (JRequest::getVar('method', '') != 'payment') {
            return NULL;
        }
        if (self::$flag) return null;
        $jlang = JFactory::getLanguage();
        $jlang->load('plg_vmpayment_rbspayment', JPATH_ADMINISTRATOR);
        $payment_data = JRequest::get('get');

        vmdebug('plgVmOnPaymentResponseReceived', $payment_data);
        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }

        $rbs_order_id = $payment_data['orderId'];
        $q = 'SELECT `virtuemart_order_id` FROM `' . $this->_tablename . '` WHERE `rbs_order_id`="' . $rbs_order_id . '"';
        $db = JFactory::getDBO();
        $db->setQuery($q);
        $virtuemart_order_id = $db->loadResult();


        $q = 'SELECT `virtuemart_paymentmethod_id` FROM `' . $this->_tablename . '` WHERE `rbs_order_id`="' . $rbs_order_id . '"';
        $db = JFactory::getDBO();
        $db->setQuery($q);
        $virtuemart_paymentmethod_id = $db->loadResult();
        $method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);

        $args = Array(
            'userName' => $method->merchant,
            'password' => $method->password,
            'orderId' => $rbs_order_id,
        );

        if ($method->test_mode == '1') {
            $action_adr = RBS_TEST_URL;
        } else {
            $action_adr = RBS_PROD_URL;
        }
        $action_adr .= 'getOrderStatus.do';

        $rbsCurl = curl_init();
        curl_setopt_array($rbsCurl, array(
            CURLOPT_URL => $action_adr,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_SSL_VERIFYPEER => false,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => http_build_query($args),
        ));
        $response = curl_exec($rbsCurl);
        curl_close($rbsCurl);
        $response = json_decode($response, true);
//        if ($method->test_mode) {
            $this->rbs_logInfo($action_adr, json_encode($args), json_encode($response));
//        }

        $modelOrder = VmModel::getModel('orders');
        $orderStatus = $response['OrderStatus'];

        if ($orderStatus == '1' || $orderStatus == '2') {


            $order = array();
            $current_order = $modelOrder->getOrder($virtuemart_order_id);

            $html .= "Заказ ". $current_order['details']['BT']->order_number . " успешно оплачен.";

            $order['order_status'] = "C";
            $order['comments'] = 'RBSPayment [' . $rbs_order_id . ']';


            if ($current_order['details']['BT']->order_status != "C") {
                $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
            }

            if (!class_exists('VirtueMartCart')) {
                require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
            }
            $cart = VirtueMartCart::getCart();
            if (!class_exists('VirtueMartModelOrders')) {
                require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
            }

            $cart->emptyCart();
            self::$flag = true;
            return true;

        } else {

            $order = array();
            $order['order_status'] = "X";
            $order['comments'] = 'RBSPayment ' . $rbs_order_id;
            $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
            $html .= 'При оплате произошла ошибка. Попробуйте <a href="' . JURI::root() . 'index.php?option=com_virtuemart&view=cart">еще раз</a>.';
        }

        return null;
    }

    function plgVmOnUserPaymentCancel()
    {
        return null;
    }

    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
    {
        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart)
    {
        return $this->OnSelectCheck($cart);
    }

    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn)
    {
        $this->cart = $cart;
        return $this->displayListFE($cart, $selected, $htmlIn);
    }

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
    {
        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
    {

        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null;
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $this->getPaymentCurrency($method);
        $paymentCurrencyId = $method->payment_currency;
    }

    function logingActions($params)
    {
        jimport('joomla.error.log');
        $options = array('format' => "{DATE}\t{TIME}\t{ORDER}\t{ACTION}");
        $log = &JLog::getInstance('payment_events.log.php', $options);
        $log->addEntry(array('ORDER' => $params['ORDER'], 'ACTION' => $params['ACTION']));
    }

    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array())
    {
        return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
    {
        $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    function plgVmonShowOrderPrintPayment($order_number, $method_id)
    {
        return $this->onShowOrderPrint($order_number, $method_id);
    }

    function plgVmDeclarePluginParamsPayment($name, $id, &$data)
    {
        return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
        return $this->setOnTablePluginParams($name, $id, $table);
    }

    function plgVmDeclarePluginParamsPaymentVM3(&$data)
    {
        return $this->declarePluginParams('payment', $data);
    }

    protected function getVmPluginCreateTableSQL()
    {
        return $this->createTableSQL('Payment RBS Table');
    }

    protected function checkConditions($cart, $method, $cart_prices)
    {
        return true;
    }
}